# spec file for qt5-qtwayland
%global qt_module qtwayland

Name:           qt5-%{qt_module}
Version:        5.15.10
Release:        1
Summary:        Qt5 - Wayland platform support and QtCompositor module
License:        LGPL-3.0-only OR GPL-3.0-only WITH Qt-GPL-exception-1.0
Url:            http://www.qt.io
%global majmin %(echo %{version} | cut -d. -f1-2)
Source0: 	https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz

## Upstream patches
## repo: https://invent.kde.org/qt/qt/qtwayland
## branch: kde/5.15
## git format-patch v5.15.8-lts-lgpl
Patch1:         0001-Client-Announce-an-output-after-receiving-more-compl.patch
Patch2:         0002-Fix-issue-with-repeated-window-size-changes.patch
Patch3:         0003-Client-Connect-drags-being-accepted-to-updating-the-.patch
Patch4:         0004-Client-Disconnect-registry-listener-on-destruction.patch
Patch5:         0005-Client-Set-XdgShell-size-hints-before-the-first-comm.patch
Patch6:         0006-Fix-build.patch
Patch7:         0007-Fix-remove-listener.patch
Patch8:         0008-Hook-up-queryKeyboardModifers.patch
Patch9:         0009-Correctly-detect-if-image-format-is-supported-by-QIm.patch
Patch10:        0010-Client-Don-t-always-recreate-frame-callbacks.patch
Patch11:        0011-Client-Always-destroy-frame-callback-in-the-actual-c.patch
Patch12:        0012-Wayland-client-use-wl_keyboard-to-determine-active-s.patch
Patch13:        0013-Client-do-not-empty-clipboard-when-a-new-popup-windo.patch
Patch14:        0014-Client-Implement-DataDeviceV3.patch
Patch15:        0015-Client-Delay-deletion-of-QDrag-object-until-after-we.patch
Patch16:        0016-Client-Avoid-processing-of-events-when-showing-windo.patch
Patch17:        0017-Handle-registry_global-out-of-constructor.patch
Patch18:        0018-Connect-flushRequest-after-forceRoundTrip.patch
Patch19:        0019-Move-the-wayland-socket-polling-to-a-separate-event-.patch
Patch20:        0020-Client-Remove-mWaitingForUpdateDelivery.patch
Patch21:        0021-client-Simplify-round-trip-behavior.patch
Patch22:        0022-Client-Fix-opaque-region-setter.patch
Patch23:        0023-Use-proper-dependencies-in-compile-tests.patch
Patch24:        0024-Revert-Client-Remove-mWaitingForUpdateDelivery.patch
Patch25:        0025-Fix-race-condition-on-mWaitingForUpdateDelivery.patch
Patch26:        0026-use-poll-2-when-reading-from-clipboard.patch
Patch27:        0027-Reduce-memory-leakage.patch
Patch28:        0028-Fix-build-with-libcxx-missing-array-include.patch
Patch29:        0029-Only-close-popup-in-the-the-hierchary.patch
Patch30:        0030-Check-pointer-for-null-before-use-in-ASSERT.patch
Patch31:        0031-Use-wl_surface.damage_buffer-on-the-client-side.patch
Patch32:        0032-Client-clear-focus-on-touch-cancel.patch
Patch33:        0033-Guard-mResizeDirty-by-the-correctMutex.patch
Patch34:        0034-Fix-compile-tests.patch
Patch35:        0035-Use-CRLF-line-delimiter-for-text-uri-list-data.patch
Patch36:        0036-Avoid-calling-requestUpdate-from-wrong-thread.patch
Patch37:        0037-Call-finishDrag-in-QWaylandDataDevice-dragSourceCanc.patch
Patch38:        0038-Hold-surface-read-lock-throughout-QWaylandEglWindow-.patch
Patch39:        0039-Keep-toplevel-windows-in-the-top-left-corner-of-the-.patch
Patch40:        0040-Client-Add-F_SEAL_SHRINK-seal-to-shm-backing-file.patch
Patch41:        0041-Client-Call-wl_output_release-upon-QWaylandScreen-de.patch
Patch42:        0042-Client-Bump-wl_output-version.patch
Patch43:        0043-Fix-frame-sync-related-to-unprotected-multithread-ac.patch
Patch44:        0044-Client-Handle-zwp_primary_selection_device_manager_v.patch
Patch45:        0045-Fixes-the-build-on-CentOS.patch
Patch46:        0046-client-Avoid-protocol-error-with-invalid-min-max-siz.patch
Patch47:        0047-Client-Fix-handling-of-Qt-BlankCursor.patch
Patch48:        0048-client-Force-a-roundtrip-when-an-XdgOutput-is-not-re.patch
Patch49:        0049-Client-Manage-QMimeData-lifecycle.patch
Patch50:        0050-client-Do-not-cast-placeholder-screens-to-QWaylandSc.patch
Patch51:        0051-Client-Remove-flip-popup-constraints.patch

Patch102:       qtwayland-decoration-support-backports-from-qt6.patch

# Upstreamable patches

# filter qml provides
%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$

BuildRequires:  make
BuildRequires:  qt5-qtbase-devel >= %{version}
BuildRequires:  qt5-qtbase-private-devel
BuildRequires:  qt5-qtbase-static
%{?_qt5:Requires: %{_qt5}%{?_isa} = %{_qt5_version}}
BuildRequires:  qt5-qtdeclarative-devel
BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(wayland-scanner) pkgconfig(wayland-server) pkgconfig(wayland-client)
BuildRequires:  pkgconfig(wayland-cursor) pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(egl) pkgconfig(gl)
BuildRequires:  pkgconfig(xcomposite) pkgconfig(xrender)
BuildRequires:  pkgconfig(libudev) pkgconfig(libinput)
BuildRequires:  libXext-devel

%description
%{summary}.

%package devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       qt5-qtbase-devel%{?_isa}

%description devel
%{summary}.

%package examples
Summary:        Programming example files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description examples
%{summary}.

%prep
%autosetup -n %{qt_module}-everywhere-src-%{version} -p1


%build
%{qmake_qt5}
%make_build


%install
make install INSTALL_ROOT=%{buildroot}

pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd


%ldconfig_scriptlets

%files
%doc README
%license LICENSE.*
%{_qt5_libdir}/libQt5WaylandCompositor.so.5*
%{_qt5_libdir}/libQt5WaylandClient.so.5*
%{_qt5_plugindir}/wayland-decoration-client/
%{_qt5_plugindir}/wayland-graphics-integration-server
%{_qt5_plugindir}/wayland-graphics-integration-client
%{_qt5_plugindir}/wayland-shell-integration
%{_qt5_plugindir}/platforms/libqwayland-egl.so
%{_qt5_plugindir}/platforms/libqwayland-generic.so
%{_qt5_plugindir}/platforms/libqwayland-xcomposite-egl.so
%{_qt5_plugindir}/platforms/libqwayland-xcomposite-glx.so
%{_qt5_qmldir}/QtWayland/

%files devel
%{_qt5_bindir}/qtwaylandscanner
%{_qt5_headerdir}/QtWaylandCompositor/
%{_qt5_headerdir}/QtWaylandClient/
%{_qt5_libdir}/libQt5WaylandCompositor.so
%{_qt5_libdir}/libQt5WaylandClient.so
%{_qt5_libdir}/libQt5WaylandCompositor.prl
%{_qt5_libdir}/libQt5WaylandClient.prl
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/Qt5WaylandCompositorConfig*.cmake
%{_qt5_libdir}/pkgconfig/*.pc
%{_qt5_archdatadir}/mkspecs/modules/*.pri
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_*.cmake
%{_qt5_libdir}/cmake/Qt5WaylandClient/

%files examples
%{_qt5_examplesdir}/wayland/


%changelog
* Mon Aug 21 2023 peijiankang <peijiankang@kylinos.cn> - 5.15.10-1
- update to upstream version 5.15.10

* Wed Oct 13 2021 peijiankang <peijiankang@kylinos.cn> - 5.15.2-1
- update to upstream version 5.15.2

* Mon Sep 14 2020 liuweibo <liuweibo10@huawei.com> - 5.11.1-6
- Fix Source0

* Thu Aug 06 2020 zhangjiapeng <zhangjiapeng9@huawei.com> - 5.11.1-5
- Add compilation dependency to solve compilation failure

* Fri Feb 14 2020 lingsheng <lingsheng@huawei.com> - 5.11.1-4
- Package init
